//Bots should have:
//.sightLength ==> How far they can see
//.intelligence ==> How fast their intelligence tick is.
$ZombieBot::damage = 20;
datablock shapeBaseImageData(BlankImage2:HammerImage)
{
	shapeFile="base/data/shapes/empty.dts";
};
function AIPlayer::canSeeObject(%this, %object)
{
	%ev = %this.getEyeVector();
	%pos = %this.getPosition();
	if(!isObject(%object))
		return 0;
	if(isFunction(%object.getClassname(), getEyePoint))
		%ep = %object.getEyePoint();
	else
		%ep = %object.getPosition();
	%vd = vectorDist(%pos, %ep);
	if(%vd > 64)
		return 0;
	%cast = containerRaycast(%pos, %ep, $TypeMasks::FxBrickObjectType);
	if(isObject(%cast))
		return 0;
	%adjp = vectorSub(%pos, %ep);
	%angle = mATan(getWord(%adjp,1), getWord(%adjp,0));
	%ea = mATan(getWord(%ev,1), getWord(%ev,0));
	%cansee = %ea - %angle;
	%canSee = mAbs(%canSee);
	if(%cansee > 3.92689 || %cansee < 2.35629)
		return 0;
	return 1;
}
function AIPlayer::doThinkMove(%this)
{
	if(%this.getState() $= "Dead")
		return;
	if(isObject(%this.getMoveObject()))
		%this.setMoveObject(0);
	%ev = %this.getEyeVector();
	%pos = %this.getPosition();
	for(%i = 0; %i < clientGroup.getCount(); %i++)
	{
		if(!isObject(%o = clientGroup.getObject(%i).player))
			continue;
		if(%o.getObjectMount() == %this.getID())
			continue;
		%ep = %o.getEyePoint();
		%vd = vectorDist(%pos, %ep);
		if(%vd > %this.sightLength)
			continue;
		%cast = containerRayCast(%pos, %ep, $TypeMasks::FxBrickAlwaysObjectType);
		if(isObject(%cast))
			continue;
		%adjp = vectorSub(%pos, %ep);
		%angle = mATan(getWord(%adjp,1), getWord(%adjp,0));
		%ea = mATan(getWord(%ev,1), getWord(%ev,0));
		%cansee = %ea - %angle;
		%canSee = mAbs(%canSee);
		if(%cansee > 3.92689 || %cansee < 2.35629)
			continue;
		if(%vd > %closestDist && %closestDist !$= "")
			continue;
		%closestDist = %vd;
		%closestObj = %o;
	}
	if(isObject(%closestObj))
	{
		%this.chasePlayer(%closestObj, %closestDist);
		return;
	}
	%this.wander();

	%this.moveSchedule = %this.schedule(1000, doThinkMove);
}
function aiPlayer::wander(%this)
{
	%this.goToPos(vectorAdd(getWords(%this.getTransform(),0,2),getRandom(-10,10) SPC getRandom(-10,10) SPC 0));
}
function aiPlayer::goToPos(%this, %pos)
{
	%this.thinkNextMove(%pos);
}
function aiPlayer::ChasePlayer(%this, %player)
{
	if(!isObject(%player))
	{
		%this.doThinkMove();
		return;
	}
	if(%player.getState() !$= "Move" || vectorDist(%this.getPosition(),%player.getPosition()) > 64)
	{
		%this.doThinkMove();
		return;
	}
	if(%this.canSeeObject(%player))
	{
		%this.setMoveObject(%player);
		if(isObject(%obj = containerRaycast(vectorSub(%this.getPosition(),"0 0 2"),%player.getEyePoint(),$TypeMasks::FxBrickObjectType)))
		{
			if(vectorDist(%this.getPosition(),%obj.getPosition()) < 4)
			{
				%this.jump();
			}
		}
		if(vectorDist(%this.getPosition(),%player.getPosition()) < 3 && %player.getState() $= "Move")
			%this.attack(%player);
		if(isObject(%player) && %player.getState() !$= "")
			%this.moveSchedule = %this.schedule(500, chasePlayer, %player);
		else
			%this.doThinkMove();
		return;
	}
	if(isObject(%this.getMoveObject()))
		%this.setMoveObject(0);
	%this.thinkNextMove(%player);
	%this.moveSchedule = %this.schedule(1000-%this.intelligence, chasePlayer, %player);
}

function AIPlayer::attack(%this, %player)
{
	if(%this.getState() !$= "Dead")
		%player.addHealth(-$ZombieBot::Damage);
}
function AIPlayer::jump(%this)
{
	%this.setJumping(true);
	%this.schedule(350,"setJumping",false);
}
function AIPlayer::ThinkNextMove(%this, %dest)
{
	if(isObject(%dest))
	{
		if(%dest.getClassName() !$= "Player")
		{
			%this.wander();
			return;
		}
		%destination = %dest.getPosition();
	}
	else
		%destination = %dest;
	%this.destination = %dest;
	%realism = 10; // Higher = more realistic
	%realismAngles = mFloor(180/%realism);
	%myangle = mRadToDeg(mATan(getWord(%ev=%this.getEyeVector(),1),getWord(%ev,0)));
	for(%i = 0; %i <= %realism; %i++)
	{
		%angle = mDegToRad(%realismAngles * %i);
		%angle = mCos(%angle) * 90;
		%angle += %myangle;
		%x = mCos(mDegToRad(%angle))*2;
		%y = mSin(mDegToRad(%angle))*2;
		%ray = containerRaycast(%this.getEyePoint(), %pos = vectorAdd(%this.getEyePoint(), %x SPC %y SPC -0), $TypeMasks::FxBrickObjectType);
		%dir = vectorAdd(%this.getPosition(), %x SPC %y SPC 0);
		if(isObject(getWord(%ray,0)))
		{
			//%ray.getID().setColor(%ray.getID().getColorID()+1);
			continue;
		}
		%dist = vectorDist(%pos, %destination);
		if(%dist < %closest || %closest $= "")
		{
			%ray = containerRayCast(vectorAdd(%this.getEyePoint(),mCos(mDegToRad(%myAngle)+1.5708) SPC mSin(mDegToRad(%myAngle)+1.5708) SPC 0), %pos, $TypeMasks::FxBrickObjectType);
			if(isObject(%ray))
				continue;
			%ray = containerRayCast(vectorAdd(%this.getEyePoint(),mCos(mDegToRad(%myAngle)-1.5708) SPC mSin(mDegToRad(%myAngle)-1.5708) SPC 0), %pos, $TypeMasks::FxBrickObjectType);
			if(isObject(%ray))
				continue;
			%closest = %dist;
			%closestpos = %pos;
			%closestdir = %dir;
		}
	}
	if(%closestpos $= "")
	{
		%myangle -= 180;
		%x = mCos(mDegToRad(%myangle))*3;
		%y = mSin(mDegToRad(%myangle))*3;
		%pos = vectorAdd(%this.getEyePoint(), %x SPC %y SPC 0);
		%closestpos = %pos;
	}
	if(getWord(vectorSub(%this.getPosition(), %destination),2) < -1.5)
	{
		%this.jump();
	}

	%this.setMoveDestination(%closestpos,0);
}

function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}