exec("./ai.cs");
exec("./app.cs");
$ZombieBot::pause=false;
$ZombieBot::PvP=false;
datablock fxDTSBrickData(botSpawnData)
{
	brickFile = "./4x4x1round.blb";
	category = "Special";
	subCategory = "Bots";
	uiName = "Bot Spawn";
	iconName = "";
};
datablock PlayerData(PlayerZombieData : PlayerStandardArmor)
{
	uiName = "Zombie";
	canJet = false;
};

function spawnzombie(%this)
{
	if(!isObject(%this))
		return;
	%this.bot = new AIPlayer()
	{
		datablock = PlayerZombieData;
		position = %this.getPosition();
		isZombie = true;
		sightLength = 30;
		home = %this;
		intelligence = 750;
		minigame = $DefaultMinigame;
	};
	if(isObject(%this.bot))
	{
		LoadApp(%this.bot,"Add-Ons/GameMode_Zombies/zombie.txt");
		ZombieDirector.add(%this.bot);
		%this.bot.mountImage(ZombieBlank,0);
		%this.bot.playThread(0,"armReadyBoth");
		%this.bot.dothinkMove();
	}
	else
	{
		error("NOTIFICATION: Bot wasn't spawned! Input brick: " @ %this);
	}
}
if(isPackage(spawnbot))
	deactivatepackage(spawnbot);
package spawnBot
{
	function minigameCanDamage(%obj1,%obj2)
	{
		if(%obj2.getClassName() $= "AIPlayer" || %obj1.getClassName() $= "AIPlayer")
		{
			if($ZombieBot::pause != true)
				return true;
		}
		if(%obj1.getClassName() $= %obj2.getClassName())
			return $ZombieBot::PvP;

		return true;
	}
	function serverCmdPlantBrick(%client)
	{
		if(%client.player.tempBrick.getDatablock().getname() $= "botSpawnData" && %client.isadmin == false)
			return;
		parent::serverCmdPlantBrick(%client);

	}
	function fxDTSBrick::onPlant(%this,%client)
	{
		parent::onPlant(%this,%client);
		if(%this.getDatablock().getName() $= "botSpawnData")
		{
			BotSpawns.add(%this);
			%this.setRendering(0);
			%this.setColliding(0);
		}
	}

	function fxDTSBrick::onLoadPlant(%this)
	{
		parent::onLoadPlant(%this);
		if(%this.getDatablock().getName() $= "botSpawnData")
		{
			BotSpawns.add(%this);
			%this.setRendering(0);
			%this.setColliding(0);
		}
	}
	function fxDTSBrick::delete(%this)
	{
		if(isObject(%this.bot))
			%this.bot.delete();
		parent::delete(%this);
	}
	function fxDTSBrick::onremove(%this)
	{
		if(isObject(%this.bot))
			%this.bot.delete();
		parent::onRemove(%this);
	}
	function gameConnection::autoAdminCheck(%client)
	{
		%r = parent::autoAdminCheck(%client);
		if(saveData.data[%client.bl_id,"level"] !$= "")
		{
			%client.exp = saveData.data[%client.bl_id,"exp"];
			%client.level = saveData.data[%client.bl_id,"level"];
			messageClient(%client,'',"\c3Your save was loaded.");
		}
		else
		{
			saveData.data[%client.bl_id,"exp"] = 0;
			saveData.data[%client.bl_id,"level"] = 1;
			%client.exp = saveData.data[%client.bl_id,"exp"];
			%client.level = saveData.data[%client.bl_id,"level"];
			messageClient(%client,'',"\c3You now have an automatic save.");
		}
		%client.clanprefix = "\c7[\c4" @ %client.level @ "\c7]";
		%client.clansuffix = "";
	}
	function serverCmdMessageSent(%client,%msg)
	{
		%client.clanprefix = "\c7[\c4" @ %client.level @ "\c7]";
		%client.clansuffix = "";
		parent::serverCmdMessageSent(%client,%msg);
	}
	function Armor::damage(%this,%damaged,%sourceObject,%position,%damage)
	{
		if(%sourceObject.getClassname() $= "Player")
		{
			%damage += mCeil(%sourceObject.client.level / 2);
		}
		%currDamage = %damaged.getDamageLevel();
		%r = parent::damage(%this,%damaged,%sourceObject,%position,%damage);
		if(%damaged.getClassName() $= "AIPlayer")
		{
			%dam = %currDamage + %damage;
			if(%dam > %damaged.getDatablock().maxDamage)
			{
				%brick = %damaged.home;
				if(!isEventPending(%brick.deathTick))
					%brick.deathTick = schedule(getRandom(40 * 1000,60 * 1000),0,"spawnzombie",%damaged.home);
				%client = %sourceObject.client;
				if(isObject(%client))
				{
					%client.exp = %client.exp + getRandom(1,3);
					if(%client.exp > %client.level * 10)
					{
						announce(%client.name @ " \c6leveled up to level " @ %client.level + 1);
						%client.level = %client.level+1;
						saveData.data[%client.bl_id,"level"] = %client.level;
						%client.exp = 0;
						saveData.data[%client.bl_id,"exp"] = 0;
						%client.clanprefix = "\c7[\c4" @ %client.level @ "\c7]";
						%client.clansuffix = "";
					}
					else
					{
						saveData.data[%client.bl_id,"exp"] = %client.exp;
						commandToClient(%client,'centerPrint',"<color:ffff00>EXP: " @ %client.exp @"/" @ %client.level * 10,2);
					}
				}
			}
			else
			{
				%damaged.chasePlayer(%sourceObject);
			}
		}

		return %r;
	}
};activatepackage(spawnBot);

function ZombieDirector::onTick(%this)
{
	%cnt = %this.getCount();
	if(%cnt < %this.minZombies)
	{
		%spawn = %this.minZombies - %cnt + getRandom(-3,7);
		for(%i=0;%i<%spawn;%i++)
		{
			%brick = BotSpawns.getObject(getRandom(0,BotSpawns.getCount()));
			spawnzombie(%brick);
		}
	}
	%this.tickloop = schedule(getRandom(30,50),0,"BotTick");
}
function TickBot()
{
	ZombieDirector::onTick(ZombieDirector.getID());
}

if(!isObject(saveData))
{
	new ScriptObject(saveData);
	new SimSet(BotSpawns);
	new SimGroup(ZombieDirector)
	{
		minZombies = 22;
		maxZombies = 40;
	};
	schedule(6000,0,"TickBot");
}